﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Caching;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using Infragistics.Web.Mvc;

namespace FileUploadSvc
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "UploadService" in code, svc and config file together.
    // NOTE: In order to launch WCF Test Client for testing this service, please select UploadService.svc or UploadService.svc.cs at the Solution Explorer and start debugging.

    [ServiceBehavior(InstanceContextMode = InstanceContextMode.Single)]
    public class UploadService : IUploadService
    {

        Dictionary<string, UploadInfo> _dictFiles = new Dictionary<string, UploadInfo>();
        private const string CacheKey = "dictFiles";
        ObjectCache cache = MemoryCache.Default;

        public void SetData(Dictionary<string, UploadInfo> dict)
        {
            try
            {
                if (dict != null)
                {
                    this._dictFiles = Merge(new Dictionary<string, UploadInfo>[] { dict, this._dictFiles });
                }
            }
            catch (Exception ex)
            {

            }
        }

        public bool RemoveData(string key)
        {
            bool isRemoved = false;
            if (this._dictFiles != null && this._dictFiles.ContainsKey(key))
            {
                isRemoved = this._dictFiles.Remove(key);
            }
            return isRemoved;
        }

        public Dictionary<string, UploadInfo> Merge(Dictionary<string, UploadInfo>[] dictionaries)
        {
            return dictionaries.SelectMany(x => x)
                .ToLookup(pair => pair.Key, pair => pair.Value)
                .ToDictionary(group => group.Key, group => group.First());
        }

        public Dictionary<string, UploadInfo> GetData()
        {
            return this._dictFiles;
        }


    }
}
